Mesh Scripting: Difference between revisions

From FreeCAD Documentation
(Marked this version for translation)
mNo edit summary
(6 intermediate revisions by the same user not shown)
Line 11: Line 11:
<translate>
<translate>


== Introduction == <!--T:1-->
==Introduction== <!--T:1-->


<!--T:25-->
<!--T:25-->
Line 26: Line 26:
of the FreeCAD C++ Mesh-Kernel.
of the FreeCAD C++ Mesh-Kernel.


== Creation and Loading == <!--T:3-->
==Creation and Loading== <!--T:3-->
To create an empty mesh object just use the standard constructor:
To create an empty mesh object just use the standard constructor:


Line 54: Line 54:
planarMesh = [
planarMesh = [
# triangle 1
# triangle 1
[-0.5000,-0.5000,0.0000],[0.5000,0.5000,0.0000],[-0.5000,0.5000,0.0000],
[-0.5000, -0.5000, 0.0000], [0.5000, 0.5000, 0.0000], [-0.5000, 0.5000, 0.0000],
#triangle 2
#triangle 2
[-0.5000,-0.5000,0.0000],[0.5000,-0.5000,0.0000],[0.5000,0.5000,0.0000],
[-0.5000, -0.5000, 0.0000], [0.5000, -0.5000, 0.0000], [0.5000, 0.5000, 0.0000],
]
]
planarMeshObject = Mesh.Mesh(planarMesh)
planarMeshObject = Mesh.Mesh(planarMesh)
Line 64: Line 64:


<!--T:7-->
<!--T:7-->
The Mesh-Kernel takes care about creating a topological correct data structure by sorting
The Mesh-Kernel takes care about creating a topologically correct data structure by sorting
coincident points and edges together.
coincident points and edges together.


Line 70: Line 70:
Later on you will see how you can test and examine mesh data.
Later on you will see how you can test and examine mesh data.


[[#top|top]]
== Modeling == <!--T:9-->

==Modeling== <!--T:9-->


<!--T:26-->
<!--T:26-->
To create regular geometries you can use the Python script BuildRegularGeoms.py.
To create regular geometries you can use the Python script {{FileName|BuildRegularGeoms.py}}.


</translate>
</translate>
Line 83: Line 85:
<!--T:10-->
<!--T:10-->
This script provides methods to define simple rotation bodies like spheres, ellipsoids, cylinders, toroids and cones. And it also has a method to create a simple cube.
This script provides methods to define simple rotation bodies like spheres, ellipsoids, cylinders, toroids and cones. And it also has a method to create a simple cube.
To create a toroid, for instance, can be done as follows:
A toroid, for instance, can be created as follows:


</translate>
</translate>
Line 93: Line 95:


<!--T:11-->
<!--T:11-->
The first two parameters define the radiuses of the toroid and the third parameter is a sub-sampling factor for how many triangles are created. The higher this value the smoother and the lower the coarser the body is.
The first two parameters define the radii of the toroid and the third parameter is a sub-sampling factor for how many triangles are created. The higher this value the smoother and the lower the coarser the body is.
The Mesh class provides a set of boolean functions that can be used for modeling purposes. It provides union, intersection and difference of two mesh objects.
The Mesh class provides a set of boolean functions that can be used for modeling purposes. It provides union, intersection and difference of two mesh objects.


Line 116: Line 118:
{{Code|code=
{{Code|code=
import Mesh, BuildRegularGeoms
import Mesh, BuildRegularGeoms
sphere = Mesh.Mesh( BuildRegularGeoms.Sphere(5.0, 50) )
sphere = Mesh.Mesh(BuildRegularGeoms.Sphere(5.0, 50))
cylinder = Mesh.Mesh( BuildRegularGeoms.Cylinder(2.0, 10.0, True, 1.0, 50) )
cylinder = Mesh.Mesh(BuildRegularGeoms.Cylinder(2.0, 10.0, True, 1.0, 50))
diff = sphere
diff = sphere
diff = diff.difference(cylinder)
diff = diff.difference(cylinder)
d = FreeCAD.newDocument()
d = FreeCAD.newDocument()
d.addObject("Mesh::Feature","Diff_Sphere_Cylinder").Mesh=diff
d.addObject("Mesh::Feature", "Diff_Sphere_Cylinder").Mesh = diff
d.recompute()
d.recompute()
}}
}}
<translate>
<translate>


[[#top|top]]
== Examining and Testing == <!--T:13-->


== Write your own Algorithms == <!--T:14-->
==Exporting== <!--T:15-->

== Exporting == <!--T:15-->
You can even write the mesh to a python module:
You can even write the mesh to a python module:


Line 141: Line 141:
<translate>
<translate>


[[#top|top]]
== Gui related stuff == <!--T:16-->


== Odds and Ends == <!--T:17-->
==Notes== <!--T:17-->


<!--T:27-->
<!--T:27-->
Line 152: Line 152:
<!--T:20-->
<!--T:20-->
See also [[Mesh_API|Mesh API]]
See also [[Mesh_API|Mesh API]]

[[#top|top]]


<!--T:18-->
<!--T:18-->

Revision as of 19:32, 26 May 2020

Introduction

First of all you have to import the Mesh module:

import Mesh

After that you have access to the Mesh module and the Mesh class which facilitate the functions of the FreeCAD C++ Mesh-Kernel.

Creation and Loading

To create an empty mesh object just use the standard constructor:

mesh = Mesh.Mesh()

You can also create an object from a file

mesh = Mesh.Mesh('D:/temp/Something.stl')

(A list of compatible filetypes can be found under 'Meshes' here.)

Or create it out of a set of triangles described by their corner points:

planarMesh = [
# triangle 1
[-0.5000, -0.5000, 0.0000], [0.5000, 0.5000, 0.0000], [-0.5000, 0.5000, 0.0000],
#triangle 2
[-0.5000, -0.5000, 0.0000], [0.5000, -0.5000, 0.0000], [0.5000, 0.5000, 0.0000],
]
planarMeshObject = Mesh.Mesh(planarMesh)
Mesh.show(planarMeshObject)

The Mesh-Kernel takes care about creating a topologically correct data structure by sorting coincident points and edges together.

Later on you will see how you can test and examine mesh data.

top

Modeling

To create regular geometries you can use the Python script BuildRegularGeoms.py.

import BuildRegularGeoms

This script provides methods to define simple rotation bodies like spheres, ellipsoids, cylinders, toroids and cones. And it also has a method to create a simple cube. A toroid, for instance, can be created as follows:

t = BuildRegularGeoms.Toroid(8.0, 2.0, 50) # list with several thousands triangles
m = Mesh.Mesh(t)

The first two parameters define the radii of the toroid and the third parameter is a sub-sampling factor for how many triangles are created. The higher this value the smoother and the lower the coarser the body is. The Mesh class provides a set of boolean functions that can be used for modeling purposes. It provides union, intersection and difference of two mesh objects.

m1, m2              # are the input mesh objects
m3 = Mesh.Mesh(m1)  # create a copy of m1
m3.unite(m2)        # union of m1 and m2, the result is stored in m3
m4 = Mesh.Mesh(m1)
m4.intersect(m2)    # intersection of m1 and m2
m5 = Mesh.Mesh(m1)
m5.difference(m2)   # the difference of m1 and m2
m6 = Mesh.Mesh(m2)
m6.difference(m1)   # the difference of m2 and m1, usually the result is different to m5

Finally, a full example that computes the intersection between a sphere and a cylinder that intersects the sphere.

import Mesh, BuildRegularGeoms
sphere = Mesh.Mesh(BuildRegularGeoms.Sphere(5.0, 50))
cylinder = Mesh.Mesh(BuildRegularGeoms.Cylinder(2.0, 10.0, True, 1.0, 50))
diff = sphere
diff = diff.difference(cylinder)
d = FreeCAD.newDocument()
d.addObject("Mesh::Feature", "Diff_Sphere_Cylinder").Mesh = diff
d.recompute()

top

Exporting

You can even write the mesh to a python module:

m.write("D:/Develop/Projekte/FreeCAD/FreeCAD_0.7/Mod/Mesh/SavedMesh.py")
import SavedMesh
m2 = Mesh.Mesh(SavedMesh.faces)

top

Notes

An extensive (though hard to use) source of Mesh related scripting are the unit test scripts of the Mesh-Module. In this unit tests literally all methods are called and all properties/attributes are tweaked. So if you are bold enough, take a look at the Unit Test module.

See also Mesh API

top